

data = load('Donoho-Johnstone benchmark the block data.txt');
data = zscore(data);
figure
plot(data);
data = data';

num_seg = 1:64;


[APCA_total,APCA_bits,APCA_model] = APCA_MDL_dim(data,num_seg);
[PLA_total,PLA_bits,PLA_model] = PLA_MDL(data,num_seg);
[DFT_total,DFT_bits,DFT_model] = DFT_MDL(data,num_seg);

figure
subplot(4,1,1)
plot(num_seg,APCA_bits);
hold on;
plot(num_seg,PLA_bits,'r');
hold on;
plot(num_seg,DFT_bits,'k');
title('Bit cost');

subplot(4,1,2)
plot(num_seg,APCA_model);
hold on;
plot(num_seg,PLA_model,'r');
hold on;
plot(num_seg,DFT_model,'k');
title('Model Cost');

subplot(4,1,3)
plot(num_seg,APCA_total);
hold on;
plot(num_seg,PLA_total,'r');
hold on;
plot(num_seg,DFT_total,'k');
title('Total Cost');
legend('APCA','PLA','DFT','Best');
xlabel('number of segments/coefficient from 1 to 60');
subplot(4,1,4)
plot(data);
